/* ttcb.c 
 * Copyright (C) 2002 by Nuno Miguel Neves
 * 
 * The ttcb rsa module
 */

/* The necessary header files */

/* Standard in kernel modules */

/*#include <asm/atomic.h>*/
#include <linux/kernel.h>   /* We're doing kernel work */
#include <linux/module.h>   /* Specifically, a module */
#include <linux/mm.h>
#include <linux/slab.h>
#include <linux/unistd.h>

#include <linux/config.h>
#include <linux/syscall.h>

#include <linux/msg.h>
#include <linux/sem.h>
#include <linux/shm.h>


#include "ttcb.h"
#include "mpi.h"
#include "rsa.h"

int DBG_LEVEL = 0;
int LOG_LEVEL = 0;

MODULE_AUTHOR("Nuno Miguel Neves <nneves@di.fc.ul.pt>");
MODULE_DESCRIPTION("This is a test module for the Trusted Timely Computing Base (TTCB)"); 
MODULE_LICENSE("GPL");
MODULE_PARM(DBG_LEVEL,"i");
MODULE_PARM_DESC(DBG_LEVEL,"Specify the debugging level, default is none (0)");
MODULE_PARM(LOG_LEVEL,"i");
MODULE_PARM_DESC(LOG_LEVEL,"Specify the logging level, default is none (0)");


/* My own printing function. Only one change from printk to rtl_printf.
   Only one debugging level comparison
*/

int logme(int level, const char * format, ...)
{
  char buf[256];
  int len;
  va_list args;
  int waste;

  va_start(args,format);
  len = vsprintf(buf, format, args);
  va_end(args);

  if (level < LOG_LEVEL)
    {
      len = printk(buf);
      for(waste=0;waste<10000000;waste++){}
    }
  return len;

}

/* My own printing function. Only one change from printk to rtl_printf.
   Only one debugging level comparison
*/

int debugme(int level, const char * format, ...)
{
  char buf[256];
  int len;
  va_list args;
  int waste;

  va_start(args,format);
  len = vsprintf(buf, format, args);
  va_end(args);

  if (level < LOG_LEVEL)
    {
      len = printk(buf); 
      for(waste=0;waste<10000000;waste++){}
    }

  return len;

}


MPI temp;


RSA_secret_key skey;

RSA_public_key pkey;


int sys_TTCBteste(int nbits)
{

  printk("The function was called with argument: %i\n",nbits);

  return 3;

}


int servHandler(unsigned int fifo)
{

  return 0;
}

/* Initialize the module */
int init_module(void)
{
  
  logme(1,"Initiating module...\n");
  
    
  logme(1,"Generating keys.\n");
  generate(&skey,1024);
  logme(1,"keys generated.\n");  
  
  /*  if(check_secret_key(&skey)==0) printk("RSA Key generated!\n");
  */

  printk("TTCB is ready!\n");
  /* If we return a non zero value, it means that 
   * init_module failed and the kernel module 
   * can't be loaded */
  return 0;
}


/* Cleanup - undid whatever init_module did */
void cleanup_module(void)
{
  printk("TTCB is going to die!\n");
}
