
/*
 *	mem_mng.h
 *
 *	RT-INET 1.0
 *
 *	(C)2002, Navigators Group	<www.navigators.di.fc.ul.pt>
 *		 Pedro Martins		<pmartins@di.fc.ul.pt>
 *	
 *	Memory management code
 *
 * 	Last Review Date: XX
*/

#ifndef _mem_mng
#define _mem_mng

#include <linux/config.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/string.h>
#include <linux/timer.h>
#include <linux/errno.h>
#include <linux/in.h>
#include <linux/ioport.h>
#include <linux/slab.h>
#include <linux/interrupt.h>
#include <linux/pci.h>
#include <linux/mii.h>
#include <linux/init.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/skbuff.h>
#include <linux/ethtool.h>
#include <linux/highmem.h>
#include <asm/irq.h>			
#include <asm/bitops.h>
#include <asm/io.h>
#include <asm/uaccess.h>

#define RTSKBUFF_MAGIC_NUMBER 0x23AD

typedef struct obj_list_rec* pt_obj_list;
struct obj_list_rec{
	int 			magic;
	void*			object;
	int 			id;
	int			available;
	pt_obj_list		prev_free;
	pt_obj_list		next_free;	 		 			
};

typedef struct {
	pt_obj_list	list;		//list of items
	pt_obj_list	free_list;	//free list links
	int		sizeof_item;
	int		n_items;   
	spinlock_t*	slock;
} object_list;

extern int init_obj_list(object_list* olist, int n_items, int size_item);
extern void free_obj_list(object_list* olist);
extern void free_obj_list_item(object_list* olist, pt_obj_list rec);
extern pt_obj_list get_obj_list_item(object_list* olist);
extern void debug_display_obj_list(object_list* olist);

#endif

