package ttcb;

/**
 * Title:        Trusted Timely Computing Base (TTCB) for Java
 * Description:  Implementing a class that encapsulates TTCB C code.
 * Copyright:    Copyright (c) 2001
 * Company:      LASIGE-DI-FC-UL
 * @author Lau Cheuk Lung and Miguel Correia
 * @version 1.0
 */



public class TTCB {  

  public TTCB() {
  }

  public native int openTCBConnection(descriptor_t descriptor); 
  public native int closeTCBConnection(descriptor_t descriptor);
  public native int getTCBGlobalTimestamp(descriptor_t descriptor, timestamp_out_t ts);


//-----------------
// Agreement service

  public native propose_out_t propose(descriptor_t descriptor, short[] elist, long tstart, byte decision, byte[] value); 
  public native decide_out_t decide(descriptor_t descriptor, short tag);

//-----------------
// Random Number service

  public native rand_out_t getRandom(descriptor_t descriptor);

//-----------------
// Other APIs


//  public native byte crashedLocalTTCBid(descriptor_t descriptor, byte localTTCBid);
  public native byte crashedLocalTTCBeid(descriptor_t descriptor, short eid);

  static {
    try {
      System.loadLibrary("TTCB");
    }
    catch (UnsatisfiedLinkError e) {
      System.out.println(e);
      System.exit(1);
    }
  }
}

