/*
	rtip wrapper code for the TTCB	
*/

#ifndef MODULE
#define MODULE
#endif

#include <linux/config.h>
#if defined(CONFIG_MODVERSIONS) && !defined(MODVERSIONS)
#	define MODVERSIONS 
#endif

#ifdef MODVERSIONS
#	include <linux/modversions.h>
#endif

#include <linux/module.h>
#include "tcb/TCBnetdevice.h"
#include "rtip/RTdev.h"


MODULE_LICENSE("GPL");

// send a time replicated message - broadcast
int sendMessage(void * buff, int len, unsigned char count)
{
	int a;

	for (a=0;a<count;a++){
		RTsendMessage(buff,len); 
	}
	return 0;
}

int readMessage(void* buff,RTIME* rcvTime)
{	
	struct RTsk_buff* in_read_buff;		

	in_read_buff = RTreadMessage();	
	if (in_read_buff!=NULL){
		*rcvTime = in_read_buff->timestamp;
 	 	memcpy(buff,in_read_buff->data,in_read_buff->len);
		RTreleaseMessage(in_read_buff);
   		return 1;
	}
	 return 0;
}

int getNetMTU(void)
{
	return RTgetMTU();
}

u64 getMacAddr(void)
{
	return RTgetMacAddr();
}

void startReceive(void)
{
	RTstartReceive();
}

void stopReceive(void)
{
	RTstopReceive();
}

int init_module(void)
{	
	return 0;  
}

void cleanup_module(void)
{
}
