
#include <linux/config.h>
#if defined(CONFIG_MODVERSIONS) && !defined(MODVERSIONS)
#	define MODVERSIONS 
#endif

#ifdef MODVERSIONS
#	include <linux/modversions.h>
#endif


#include <linux/config.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/string.h>
#include <linux/timer.h>
#include <linux/errno.h>
#include <linux/in.h>
#include <linux/ioport.h>
#include <linux/slab.h>
#include <linux/interrupt.h>
#include <linux/pci.h>
#include <linux/mii.h>
#include <linux/init.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/skbuff.h>
#include <linux/ethtool.h>
#include <linux/highmem.h>
#include <asm/irq.h>		
#include <asm/bitops.h>
#include <asm/io.h>
#include <asm/uaccess.h>

#include "rtip/RTdev.h"

MODULE_LICENSE("GPL");

unsigned int n_skbuffs=(128*1024)/sizeof(struct RTsk_buff);


MODULE_AUTHOR ("Pedro Martins <pmartins@di.fc.ul.pt>");
MODULE_DESCRIPTION ("RTIP 1.0 - Real-Time UDP/IP for RTAI");
MODULE_PARM (n_skbuffs,"i");
MODULE_PARM_DESC (n_skbuffs,"number of RTskbuffs to allocate");

extern struct RTnet_device loopback;

void print_about(void){
	printk(KERN_INFO "------------------------------------------------------\n");
	printk(KERN_INFO "RTIP 1.0 - Real-Time UDP/IP for RTAI\n");
	printk(KERN_INFO "(C)2002, Navigators Group <www.navigators.di.fc.ul.pt>\n");
	printk(KERN_INFO "         Pedro Martins    <pmartins@di.fc.ul.pt>\n");
	printk(KERN_INFO "------------------------------------------------------\n");
}

static int __init vortex_init (void)
{	
//int a;
//char * p;
//struct RTsk_buff* bu; 
//char st[10];

	print_about();

	printk(KERN_INFO "\nAllocating memory objects:\n");
	printk  (KERN_INFO "  .%d RTskbuffs:",n_skbuffs);
	if (initRTskbuffs(n_skbuffs)){
		printk(KERN_ERR "Memory failure on allocating %d RTsk_buffs -->\n",n_skbuffs);
		return -ENOMEM;
	}
	 printk(KERN_INFO "Ok\n");	

	printk  (KERN_INFO "  .%d RTskbuffs for backlog rx:",n_skbuffs);
	if (rtnet_dev_init(n_skbuffs)){
		printk(KERN_ERR "Memory failure on allocating %d RTsk_buffs -->\n",n_skbuffs);
		endRTskbuffs();		
		return -ENOMEM;
	}
	 printk(KERN_INFO "Ok\n");	

	 printk  (KERN_INFO "  .starting built-in loopback device: ");

	//start loopback device
	if (RTloopback_init(&loopback)){
		printk(KERN_ERR "Cannot start loopback device\n");
		endRTskbuffs();
		rtnet_dev_close();
		return -ENOMEM;
	}
	printk(KERN_INFO "Ok\n");	

	printk(KERN_INFO "\nRTIP is running ....\n");

#if 0
PARA SAIR
  for (a=0;a<20;a++){
  	sprintf(st,"PKT%d\n\0",a);
   	RTsendMessage(st,7);
  }

  printk("Envios\n");

  for (a=0;a<20;a++){
 	 bu = RTreadMessage(&p);
 	if (bu!=NULL){
 		RTskb_pull(bu,14);
 		printk("%d %s\n",a,bu->data);
 		RTreleaseMessage(bu);
 	}
 	else
 	printk("Nepia\n");
  }
  
   for (a=0;a<20;a++){
   	RTsendMessage("Paulo\n\0",7);
  }

  printk("Envios\n");

  for (a=0;a<20;a++){
 	 bu = RTreadMessage(&p);
 	if (bu!=NULL){
 		RTskb_pull(bu,14);
 		printk("%d %s\n",a,bu->data);
 		RTreleaseMessage(bu);
 	}
 	else
 	printk("Nepia\n");
  }
  #endif
	
	return 0;
}


static void __exit vortex_cleanup (void)
{	
	rtnet_dev_close();
	endRTskbuffs();
}


module_init(vortex_init);
module_exit(vortex_cleanup);

